package org.eclipse.papyrus.sysml.facets.portandflows.query.value.getter;

import org.eclipse.emf.facet.infra.query.core.exception.ModelQueryExecutionException;
import org.eclipse.emf.facet.infra.query.core.java.IJavaModelQuery;
import org.eclipse.emf.facet.infra.query.core.java.ParameterValueList;
import org.eclipse.papyrus.sysml.portandflows.FlowPort;
import org.eclipse.papyrus.sysml.util.ElementUtil;
import org.eclipse.uml2.uml.Port;

/** Query to get the derived attribute "isAtomic" of the FlowPort */
public class GetFlowPortIsAtomicQuery implements IJavaModelQuery<Port, Boolean> {

	/**
	 * 
	 * @see org.eclipse.emf.facet.infra.query.core.java.IJavaModelQuery#evaluate(org.eclipse.emf.ecore.EObject,
	 *      org.eclipse.emf.facet.infra.query.core.java.ParameterValueList)
	 * 
	 * @param context
	 * @param parameterValues
	 * @return
	 * @throws ModelQueryExecutionException
	 */
	public Boolean evaluate(final Port context, final ParameterValueList parameterValues)
			throws ModelQueryExecutionException {
		FlowPort flowPort = ElementUtil.getStereotypeApplication(context, FlowPort.class);
		if(flowPort != null) {
			return flowPort.isIsAtomic();
		}
		return null;
	}
}
